/* MoreLayoutsforThunderbird.js */

/* Need this at startup */
var gDOMChangedFolderPaneOrThreadPane;
const kStackedPaneConfig = 4;

// aMsgWindowInitialized: false if calling from the onload handler, otherwise true
function UpdateMailPaneConfig(aMsgWindowInitialized) {

  const dynamicViewName = ["classic", "widemessage", "vertical", "widethread", "stacked"];
  const dynamicViewResetDOMType = [kWideThreadPaneConfig, kStackedPaneConfig];
  var paneConfig = pref.getIntPref("mail.pane_config.dynamic");

  // Set to Classic if invalid value or onload startup;
  // if in accountcentral, widethread & stacked must be simulated to classic
  // otherwise accountcentral does not display right.
  if (paneConfig >= dynamicViewName.length || 
      aMsgWindowInitialized == false || 
     (gAccountCentralLoaded && 
         (dynamicViewResetDOMType.indexOf(paneConfig) != -1))) 
    paneConfig = kStandardPaneConfig; 

  // Set view name for css selectors 
  var viewName = (gAccountCentralLoaded ? "accountcentral" : dynamicViewName[paneConfig]);
  document.getElementById("mailContent").setAttribute("view", viewName);

  if (paneConfig == gCurrentPaneConfig) 
    // No change required
    return;

  // Indicate if DOM changed, necessary to reset Lighting when switching modes
  if (dynamicViewResetDOMType.indexOf(paneConfig) != -1 || 
      (dynamicViewResetDOMType.indexOf(paneConfig) == -1 &&
          dynamicViewResetDOMType.indexOf(gCurrentPaneConfig) != -1) ||
      (dynamicViewResetDOMType.indexOf(paneConfig) != -1 &&
          dynamicViewResetDOMType.indexOf(gCurrentPaneConfig) == -1))
    gDOMChangedFolderPaneOrThreadPane = true;
  else
    gDOMChangedFolderPaneOrThreadPane = false;

  const dynamicIdsMessagePane = ["messagesBox", "mailContentWrapper", "messengerBox", "messagesBox", "mailContentWrapper"];
  const dynamicIdsThreadPane = ["messagesBox", "messagesBox", "messagesBox", "mailContentWrapper", "messagesBox"];
  const dynamicMailContentOrient = ["horizonal", "horizonal", "horizonal", "horizonal", "vertical"];
  const dynamicMailContentWrapperOrient = ["horizonal", "vertical", "horizonal", "vertical", "horizonal"];
  const dynamicMessagesBoxOrient = ["vertical", "vertical", "horizonal", "vertical", "vertical"];
  const dynamicThreadPaneSplitterOrient = ["vertical", "vertical", "horizonal", "vertical", "horizonal"];
  const dynamicMessagePaneBoxFlex = [1, 0, 0, 1, 0];
  //const dynamicMailContentFlex = [1, 0, 1, 1, 1];

  var desiredIdMessagePane = dynamicIdsMessagePane[paneConfig];
  var desiredIdThreadPane = dynamicIdsThreadPane[paneConfig];

  var messengerBox = document.getElementById("messengerBox");// threadpane+acct central
  var messagePaneBox = GetMessagePane();//#messagepanebox
  var messagePaneSplitter = GetThreadAndMessagePaneSplitter();// #threadpane-splitter

  if (messagePaneBox.parentNode.id != desiredIdMessagePane) {
    var desiredParent = document.getElementById(desiredIdMessagePane);

    // See Bug 381992. The ctor for the browser element will fire again when 
    // we re-insert the messagePaneBox back into the document.
    // But the dtor doesn't fire when the element is removed from the document. 
    // Manually call destroy here to avoid a nasty leak.
    if (document.getElementById("messagepane").nodeName != "tabbrowser")
      // For non tabbed build only
      getMessageBrowser().destroy();

    desiredParent.appendChild(messagePaneSplitter);
    desiredParent.appendChild(messagePaneBox);
  }

  if (messengerBox.parentNode.id != desiredIdThreadPane) {
    var desiredParent = document.getElementById(desiredIdThreadPane);
    switch (paneConfig) {
      case kStandardPaneConfig: // 0
      case kWideThreadPaneConfig: // 3
        desiredParent.insertBefore(messagePaneSplitter, desiredParent.firstChild);
        desiredParent.insertBefore(messengerBox, desiredParent.firstChild);
        break;
      case kWidePaneConfig: // 1
      case kVerticalPaneConfig: // 2
      case kStackedPaneConfig: // 4
        if (gCurrentPaneConfig != kWideThreadPaneConfig) 
          desiredParent.appendChild(messagePaneSplitter);
        desiredParent.appendChild(messengerBox);
        break;
    }
    // Reset threadpane and account central references after move
    try {RerootThreadPane();} catch (ex) {}
    accountCentralBox = document.getElementById("accountCentralBox");
  }
  // Set element orient states for a given view
  document.getElementById("mailContentWrapper").orient = dynamicMailContentWrapperOrient[paneConfig];
  document.getElementById("mailContent").orient = dynamicMailContentOrient[paneConfig];
  document.getElementById("messagesBox").orient = dynamicMessagesBoxOrient[paneConfig];
  document.getElementById("folderpane_splitter").orient = dynamicMailContentOrient[paneConfig];
  messagePaneSplitter.orient = dynamicThreadPaneSplitterOrient[paneConfig];

  // Make sure dimensions always maintained as set
  messagePaneBox.setAttribute("flex", dynamicMessagePaneBoxFlex[paneConfig]);
  document.getElementById("mailContent").setAttribute("persist", "height"); 
  document.getElementById("folderPaneBox").setAttribute("persist", "height"); 
  // For vertical view state..
  document.getElementById("displayDeck").setAttribute("persist", "width"); 

  // For xSidebar in Stacked View
  if (document.getElementById("sidebar-splitter")) {
    var insertWhere = document.getElementById("mailContent");
    var xSidebar = document.getElementById("sidebar-box");
    var xSidebarSplitter = document.getElementById("sidebar-splitter");
    if (paneConfig == kStackedPaneConfig) {
      insertWhere.parentNode.insertBefore(xSidebar, insertWhere);
      insertWhere.parentNode.insertBefore(xSidebarSplitter, insertWhere);
      //document.getElementById("sidebar-splitter").orient = dynamicMailContentOrient[paneConfig];
      //var setflex = (((xSidebar.getAttribute("sidebarVisible") == true) && paneConfig == kStackedPaneConfig) ? 1 : 0)
      //xSidebar.setAttribute("flex", setflex);
      //document.getElementById("folderPaneBox").setAttribute("flex", setflex);
    }
    else
      // only do if switch from stacked view..
      if (gCurrentPaneConfig == kStackedPaneConfig) {
        insertWhere.insertBefore(xSidebarSplitter, insertWhere.firstChild);
        insertWhere.insertBefore(xSidebar, insertWhere.firstChild);
      }
  }
  
  
  // Record the new configuration
  gCurrentPaneConfig = paneConfig; 
  debugMLfTB("layout changed to -> " + viewName);

  UpdateLightningTodayPaneConfig();

  // re-rooting the message pane causes the docshell to get destroyed and 
  // replaced with another one. As such, we need to re-set the window (and thus
  // the internal references nsMessenger keeps for the message pane docshell)
  if (aMsgWindowInitialized) {
    if (document.getElementById("messagepane").nodeName == "tabbrowser") {
      var messageBrowser = getMessageBrowser();
      messenger.SetMessagePaneDocShell(msgWindow, messageBrowser.docShell);
    }
    else {
      messenger.SetWindow(null, null);
      messenger.SetWindow(window, msgWindow);
    }

    if (gDBView && GetNumSelectedMessages() == 1) MsgReload(); 
  }
}

/* Override Tb native function */
function ShowAccountCentral() {
  var accountBox = document.getElementById("accountCentralBox");
  document.getElementById("displayDeck").selectedPanel = accountBox;

  gAccountCentralLoaded = true;
  HidingThreadPane();
  UpdateMailPaneConfig(true);

  var acctCentralPage = pref.getComplexValue("mailnews.account_central_page.url",
      Components.interfaces.nsIPrefLocalizedString).data;
  // Frame reference lost with WideThreadPaneConfig, load it less elegantly.. 
  //window.frames["accountCentralPane"].location.href = acctCentralPage;
  accountCentralBox.firstChild.contentDocument.location.href = acctCentralPage;
}

/* Override Tb native function */
function ShowThreadPane() {
  var panelID = document.getElementById("displayDeck").selectedPanel.id;

  document.getElementById("displayDeck").selectedPanel = 
    document.getElementById("threadPaneBox");
  if (!(panelID == "calendar-view-box" || panelID == "calendar-task-box"))
    UpdateMailPaneConfig(true)
}

function BrowserFullScreen() {
  var mtbxCollapsed = document.getElementById("mail-toolbox").collapsed;
  // Rest must have same collapsed state as mail-toolox 
  document.getElementById("mail-toolbox").setAttribute("collapsed", !mtbxCollapsed);
  document.getElementById("status-bar").setAttribute("collapsed", !mtbxCollapsed);
  if (!gAccountCentralLoaded) {
    document.getElementById("folderPaneBox").setAttribute("collapsed", !mtbxCollapsed);
    document.getElementById("threadpane-splitter").setAttribute("collapsed", !mtbxCollapsed);
    document.getElementById("folderpane_splitter").setAttribute("collapsed", !mtbxCollapsed);
    switch (gCurrentPaneConfig) {
      case kStandardPaneConfig: // 0
      case kWideThreadPaneConfig: // 3
        document.getElementById("messengerBox").setAttribute("collapsed", !mtbxCollapsed);
        break;
      case kWidePaneConfig: // 1
        document.getElementById("mailContent").setAttribute("collapsed", !mtbxCollapsed);
        var setflex = (!mtbxCollapsed ? 1 : 0)
        document.getElementById("messagepanebox").setAttribute("flex", setflex);
        break;
      case kStackedPaneConfig: // 4
        document.getElementById("mailContent").setAttribute("collapsed", !mtbxCollapsed);
        break;
      case kVerticalPaneConfig: // 2
        document.getElementById("displayDeck").setAttribute("collapsed", !mtbxCollapsed);
        break;
    }
    if (document.getElementById("sidebar-splitter")) { // xSidebar
      document.getElementById("sidebar-box").setAttribute("collapsed", !mtbxCollapsed);;
      document.getElementById("sidebar-splitter").setAttribute("collapsed", !mtbxCollapsed);
    }
  }

  window.fullScreen = !window.fullScreen;
}

/* Console logger */
function debugMLfTB(aMsg) 
{
  Components.classes["@mozilla.org/consoleservice;1"]
                     .getService(Components.interfaces.nsIConsoleService)
                     .logStringMessage("MoreLayoutsforTb::"+
                        arguments.callee.caller.name+": " + aMsg);
}